From 4d81851df4c2715f7df832a2cb9cf79d9cf7406d Mon Sep 17 00:00:00 2001
From: Sebastiii <sebastiii@team-mediaportal.com>
Date: Sun, 23 Mar 2014 18:58:07 +0100
Subject: [PATCH 1/2] Fork : Tag 1.0.0.4 + Nevcariel (addon) Fix Display
 Enumeration Implement Live-Input through
 DesktopDuplication API (Windows 8 and above) Increase
 image size and zone count Prevent a crash when exiting
 while the settings window is open.

---
 AtmoDefs.h                             |   4 +-
 AtmoDesktopDuplicationCaptureInput.cpp | 237 ++++++++
 AtmoDesktopDuplicationCaptureInput.h   |  55 ++
 AtmoTools.cpp                          |   3 +-
 AtmoWinA.vcxproj                       | 960 +++++++++++++++++----------------
 AtmoWinA.vcxproj.filters               | 928 +++++++++++++++----------------
 AtmoWinTrayIconHandler.cpp             | 871 +++++++++++++++---------------
 AtmoWinTrayIconHandler.h               |   1 +
 dlldata.c                              |  37 ++
 9 files changed, 1719 insertions(+), 1377 deletions(-)
 create mode 100644 AtmoDesktopDuplicationCaptureInput.cpp
 create mode 100644 AtmoDesktopDuplicationCaptureInput.h
 create mode 100644 dlldata.c

diff --git a/AtmoDefs.h b/AtmoDefs.h
index 7906137..9f74f84 100644
--- a/AtmoDefs.h
+++ b/AtmoDefs.h
@@ -88,8 +88,8 @@ typedef struct
 // #define CAP_WIDTH    88
 
 #ifdef CAP_16x9
-# define CAP_WIDTH    88
-# define CAP_HEIGHT   48
+# define CAP_WIDTH    480
+# define CAP_HEIGHT   270
 #else
 # define CAP_WIDTH  64 //  46  // 128
 # define CAP_HEIGHT  48 // 26  // 64
diff --git a/AtmoDesktopDuplicationCaptureInput.cpp b/AtmoDesktopDuplicationCaptureInput.cpp
new file mode 100644
index 0000000..555f322
--- /dev/null
+++ b/AtmoDesktopDuplicationCaptureInput.cpp
@@ -0,0 +1,237 @@
+
+#include "stdafx.h"
+#include "AtmoDesktopDuplicationCaptureInput.h"
+
+#pragma comment( lib, "dxgi" )
+#pragma comment( lib, "d3d11" )
+
+template <class T> void SafeRelease(T **ppT)
+{
+    if (*ppT)
+    {
+        (*ppT)->Release();
+        *ppT = nullptr;
+    }
+}
+
+static inline int divRoundClosest(const UINT n, const UINT d)
+{
+    return ((n + d / 2) / d);
+}
+
+CAtmoDesktopDuplicationCaptureInput::CAtmoDesktopDuplicationCaptureInput(CAtmoDynData *pAtmoDynData)
+ : CAtmoInput(pAtmoDynData)
+ , m_pOutput(NULL)
+ , m_pOutputDuplication(NULL)
+ , m_pD3D11Device(NULL)
+ , m_pD3D11DeviceContext(NULL)
+ , m_pTexture(NULL)
+ , m_bThreadStarted(false)
+{
+}
+
+CAtmoDesktopDuplicationCaptureInput::~CAtmoDesktopDuplicationCaptureInput(void)
+{
+    SafeRelease(&m_pOutputDuplication);
+    SafeRelease(&m_pOutput);
+    SafeRelease(&m_pTexture);
+    SafeRelease(&m_pD3D11Device);
+    SafeRelease(&m_pD3D11DeviceContext);
+}
+
+ATMO_BOOL CAtmoDesktopDuplicationCaptureInput::Open()
+{
+    HRESULT hr = S_OK;
+    CAtmoConfig *pAtmoConfig = m_pAtmoDynData->getAtmoConfig();
+    CAtmoDisplays *pAtmoDisplays = m_pAtmoDynData->getAtmoDisplays();
+
+    // clear temp hsv image
+    memset(&HSV_Img, 0, IMAGE_SIZE * sizeof(tHSVColor));
+
+    int displayNr = pAtmoConfig->getLiveView_DisplayNr();
+    if (displayNr >= pAtmoDisplays->getCount())
+        displayNr = 0; // drop back to display 0 ;-)
+    TAtmoDisplayInfo displayInfo = pAtmoDisplays->getDisplayInfo(displayNr);
+
+    IDXGIAdapter1 *pAdapter = NULL;
+    GetOutput(displayInfo.vert_ScreenPos, displayInfo.horz_ScreenPos, &m_pOutput, &pAdapter);
+    if (m_pOutput == NULL) {
+        goto done;
+    }
+    
+    DXGI_OUTPUT_DESC outputDesc;
+    m_pOutput->GetDesc(&outputDesc);
+
+    m_lWidth = outputDesc.DesktopCoordinates.right - outputDesc.DesktopCoordinates.left;
+    m_lHeight = outputDesc.DesktopCoordinates.bottom - outputDesc.DesktopCoordinates.top;
+
+    ID3D11DeviceContext *pContext = NULL;
+    D3D_FEATURE_LEVEL Level;
+    hr = D3D11CreateDevice(pAdapter, D3D_DRIVER_TYPE_UNKNOWN, NULL, 0, NULL, 0, D3D11_SDK_VERSION, &m_pD3D11Device, &Level, &m_pD3D11DeviceContext);
+    if (FAILED(hr)) {
+        goto done;
+    }
+
+    D3D11_TEXTURE2D_DESC TextureDesc;
+    ZeroMemory(&TextureDesc, sizeof(TextureDesc));
+    TextureDesc.ArraySize = 1;
+    TextureDesc.CPUAccessFlags = D3D11_CPU_ACCESS_READ;
+    TextureDesc.Format = DXGI_FORMAT_B8G8R8A8_UNORM;
+    TextureDesc.Width = m_lWidth;
+    TextureDesc.Height = m_lHeight;
+    TextureDesc.MipLevels = 1;
+    TextureDesc.SampleDesc.Count = 1;
+    TextureDesc.Usage = D3D11_USAGE_STAGING;    
+
+    hr = m_pD3D11Device->CreateTexture2D(&TextureDesc, NULL, &m_pTexture);
+    if (FAILED(hr)) {
+        goto done;
+    }
+
+    hr = m_pOutput->DuplicateOutput(m_pD3D11Device, &m_pOutputDuplication);
+    if (FAILED(hr)) {
+        goto done;
+    }
+    
+    Run();
+    m_bThreadStarted = true;
+done:
+    SafeRelease(&pAdapter);
+    return true;
+}
+
+ATMO_BOOL CAtmoDesktopDuplicationCaptureInput::Close()
+{
+    if (m_bThreadStarted)
+        Terminate();
+    SafeRelease(&m_pOutputDuplication);
+    SafeRelease(&m_pOutput);
+
+    SafeRelease(&m_pTexture);
+    SafeRelease(&m_pD3D11Device);
+    SafeRelease(&m_pD3D11DeviceContext);
+    return true;
+}
+
+void CAtmoDesktopDuplicationCaptureInput::ReadImage(BYTE *pData, UINT Stride)
+{
+    tRGBColor pixelColor;
+    int index = 0;
+    // TODO: Do Bilinear scaling to the CAP_HEIGHT/CAP_WIDTH size instead of point-scaling
+    // Note: All the - 1 below can then go, as they are kludges to get to the border of the screen, and not a few pixels before
+    // and line/col then define the start of the area of the image which should be averaged
+    for(UINT y = 0; y < CAP_HEIGHT; y++)
+    {
+        UINT line = divRoundClosest((m_lHeight - 1) * y, CAP_HEIGHT - 1);
+        BYTE *pLine = pData + line * Stride;
+        for (UINT x = 0; x < CAP_WIDTH; x++)
+        {
+            UINT col = divRoundClosest((m_lWidth - 1) * x, CAP_WIDTH - 1);
+            pixelColor.b = *(pLine + col * 4 + 0);
+            pixelColor.g = *(pLine + col * 4 + 1);
+            pixelColor.r = *(pLine + col * 4 + 2);
+            HSV_Img[index++] = RGB2HSV(pixelColor);
+        }
+    }
+
+    m_pAtmoDynData->getLivePacketQueue()->AddPacket( m_pAtmoColorCalculator->AnalyzeHSV( HSV_Img ) );
+}
+
+DWORD CAtmoDesktopDuplicationCaptureInput::Execute(void)
+{
+    HRESULT hr = S_OK;
+    DXGI_OUTDUPL_FRAME_INFO FrameInfo;
+    IDXGIResource *pDesktopResource = NULL;
+    while (m_bTerminated == ATMO_FALSE)
+    {
+        hr = m_pOutputDuplication->AcquireNextFrame(1000, &FrameInfo, &pDesktopResource);
+        if (SUCCEEDED(hr)) {
+            if (FrameInfo.AccumulatedFrames > 0) {
+                ID3D11Texture2D *pDesktopResource2D = NULL;
+                hr = pDesktopResource->QueryInterface(&pDesktopResource2D);
+                if (SUCCEEDED(hr)) {
+                    m_pD3D11DeviceContext->CopyResource(m_pTexture, pDesktopResource2D);
+
+                    D3D11_MAPPED_SUBRESOURCE MappedResource;
+                    hr = m_pD3D11DeviceContext->Map(m_pTexture, 0, D3D11_MAP_READ, 0, &MappedResource);
+                    if (SUCCEEDED(hr)) {
+                        ReadImage((BYTE *)MappedResource.pData, MappedResource.RowPitch);
+                        m_pD3D11DeviceContext->Unmap(m_pTexture, 0);
+                    }
+                    SafeRelease(&pDesktopResource2D);
+                }
+            }
+
+            SafeRelease(&pDesktopResource);
+            m_pOutputDuplication->ReleaseFrame();
+        } else {
+            if (hr == DXGI_ERROR_ACCESS_LOST) {
+                SafeRelease(&m_pOutputDuplication);
+                hr = m_pOutput->DuplicateOutput(m_pD3D11Device, &m_pOutputDuplication);
+                if (FAILED(hr)) {
+                    return 1;
+                }
+            } else if (hr == DXGI_ERROR_WAIT_TIMEOUT) {
+                // Moo!
+            } else {
+                // Error?
+            }
+        }
+    }
+
+    return 0;
+}
+
+HRESULT CAtmoDesktopDuplicationCaptureInput::GetOutput(LONG vertPos, LONG horzPost, IDXGIOutput1 **ppOutput1, IDXGIAdapter1 **ppAdapter1)
+{
+    HRESULT hr = S_OK;
+    IDXGIFactory1 * pFactory = NULL;
+    hr = CreateDXGIFactory1(__uuidof(IDXGIFactory1), (void**)(&pFactory));
+    if (FAILED(hr)) {
+        return false;
+    }
+
+    UINT i = 0;
+    IDXGIAdapter1 * pAdapter;
+    while (pFactory->EnumAdapters1(i, &pAdapter) != DXGI_ERROR_NOT_FOUND && !(*ppOutput1))
+    {
+        UINT j = 0;
+        IDXGIOutput * pOutput = NULL;
+        while (pAdapter->EnumOutputs(j, &pOutput) != DXGI_ERROR_NOT_FOUND)
+        {
+            DXGI_OUTPUT_DESC desc;
+            if (SUCCEEDED(pOutput->GetDesc(&desc)) && desc.AttachedToDesktop) {
+                if (desc.DesktopCoordinates.top == vertPos && desc.DesktopCoordinates.left == horzPost) {
+                    if (SUCCEEDED(pOutput->QueryInterface(ppOutput1))) {
+                        *ppAdapter1 = pAdapter;
+                        (*ppAdapter1)->AddRef();
+                    }
+                    break;
+                }
+            }
+            SafeRelease(&pOutput);
+            j++;
+        }
+        SafeRelease(&pAdapter);
+        i++;
+    }
+
+    if (*ppOutput1 == NULL) {
+        pFactory->EnumAdapters1(0, &pAdapter);
+        if (pAdapter) {
+            IDXGIOutput * pOutput = NULL;
+            pAdapter->EnumOutputs(0, &pOutput);
+            if (pOutput) {
+                if (SUCCEEDED(pOutput->QueryInterface(ppOutput1))) {
+                    *ppAdapter1 = pAdapter;
+                    (*ppAdapter1)->AddRef();
+                }
+            }
+            SafeRelease(&pOutput);
+        }
+        SafeRelease(&pAdapter);
+    }
+
+    pFactory->Release();
+    return S_OK;
+}
diff --git a/AtmoDesktopDuplicationCaptureInput.h b/AtmoDesktopDuplicationCaptureInput.h
new file mode 100644
index 0000000..dc3f041
--- /dev/null
+++ b/AtmoDesktopDuplicationCaptureInput.h
@@ -0,0 +1,55 @@
+/*
+ * AtmoGdiDisplayCaptureInput.h: Implements the picture source which grabs the desktop as source for the live view mode
+ * poor performance ... through some GDI unsolved problems, if there are overlays active or some other applications...
+ *
+ * See the README.txt file for copyright information and how to reach the author(s).
+ *
+ * $Id$
+ */
+#pragma once
+#include "atmoinput.h"
+#include "atmothread.h"
+#include "atmoconfig.h"
+#include "AtmoCalculations.h"
+#include "AtmoDisplays.h"
+
+#include <dxgi.h>
+#include <DXGI1_2.h>
+#include <D3D11.h>
+
+class CAtmoDesktopDuplicationCaptureInput : public CAtmoInput
+{
+protected:
+   	virtual DWORD Execute(void);
+
+private:
+    HRESULT GetOutput(LONG vertPos, LONG horzPost, IDXGIOutput1 **pOutput1, IDXGIAdapter1 **pAdapter1);
+    void ReadImage(BYTE *pData, UINT Stride);
+
+private:
+    tHSVColor HSV_Img[IMAGE_SIZE];
+
+    IDXGIOutput1 *m_pOutput;
+    IDXGIOutputDuplication *m_pOutputDuplication;
+    ID3D11Device *m_pD3D11Device;
+    ID3D11DeviceContext *m_pD3D11DeviceContext;
+
+    ID3D11Texture2D *m_pTexture;
+
+    LONG m_lWidth;
+    LONG m_lHeight;
+
+    bool m_bThreadStarted;
+
+public:
+    CAtmoDesktopDuplicationCaptureInput(CAtmoDynData *pAtmoDynData);
+    virtual ~CAtmoDesktopDuplicationCaptureInput(void);
+
+    // Opens the input-device. Parameters (e.g. the device-name) can be given in 'param'.
+    // Returns true if the input-device was opened successfully.
+    virtual ATMO_BOOL Open(void);
+
+    // Closes the input-device.
+    // Returns true if the input-device was closed successfully.
+    virtual ATMO_BOOL Close(void);
+};
diff --git a/AtmoTools.cpp b/AtmoTools.cpp
index 338ec3f..7c89fde 100644
--- a/AtmoTools.cpp
+++ b/AtmoTools.cpp
@@ -31,6 +31,7 @@
 #   include "MondolightConnection.h"
 
 #   include "AtmoGdiDisplayCaptureInput.h"
+#   include "AtmoDesktopDuplicationCaptureInput.h"
 #endif
 
 
@@ -187,7 +188,7 @@ EffectMode CAtmoTools::SwitchEffect(CAtmoDynData *pDynData, EffectMode newEffect
                 }
                 currentPacketQueue = new CAtmoPacketQueue(packetMon);
                 pDynData->setLivePictureSource(lpsScreenCapture);
-                currentInput = new CAtmoGdiDisplayCaptureInput( pDynData );
+                currentInput = new CAtmoDesktopDuplicationCaptureInput(pDynData);
 #else
                 currentPacketQueue = new CAtmoPacketQueue();
                 pDynData->setLivePictureSource(lpsExtern);
